SystemOrganization addCategory: #'SqueakEnh-Focus'!

!SystemWindow methodsFor: '*sloppy focus-focus model' stamp: 'Samir Saidani 1/31/2004 02:45'!
handlesMouseDown: evt 
	"If I am not the topWindow, then I will only respond to dragging by the  
	title bar.  
	Any other click will only bring me to the top"
	Preferences sloppyFocus
		ifTrue: [self activate].
	(self labelRect containsPoint: evt cursorPoint)
		ifTrue: [^ true].
	^ self activeOnlyOnTop
		and: [self ~~ TopWindow]! !

!SystemWindow methodsFor: '*sloppy focus-focus model' stamp: 'Samir Saidani 5/11/2003 22:45'!
activateOnlyForFocus
	"Don't bring me to the front and make me only able to respond to mouse  
	and keyboard"
	| sketchEditor pal |
	self
		submorphsDo: [:m | m unlock].
	labelArea
		ifNotNil: [labelArea
				submorphsDo: [:m | m unlock].
			self setStripeColorsFrom: self paneColorToUse].
	self isCollapsed
		ifFalse: [model modelWakeUpIn: self.
			self positionSubmorphs.
			labelArea
				ifNil: [self adjustBorderUponActivationWhenLabeless]].
	(sketchEditor _ self extantSketchEditor)
		ifNotNil: [sketchEditor comeToFront.
			(pal _ self world findA: PaintBoxMorph)
				ifNotNil: [pal comeToFront]]! !

!SystemWindow methodsFor: '*sloppy focus-focus model' stamp: 'Samir Saidani 5/11/2003 22:25'!
handlesMouseOver: evt 
	^ true! !

!SystemWindow methodsFor: '*sloppy focus-focus model' stamp: ''!
mouseEnter: evt 
	"self setProperty: #clickPoint toValue: evt cursorPoint."
	TopWindow == self
		ifFalse: [evt hand releaseKeyboardFocus.
			self activateOnlyForFocus]! !

PackageInfo subclass: #SloppyFocusInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakEnh-Focus'!

!SloppyFocusInfo methodsFor: 'as yet unclassified' stamp: 'Samir Saidani 1/30/2004 00:51'!
methodCategoryPrefix
	^ '*sloppy focus'! !

!SloppyFocusInfo methodsFor: 'as yet unclassified' stamp: 'Samir Saidani 1/31/2004 17:28'!
preambleText
	Preferences
		addPreference: #sloppyFocus
		categories: #(#windows )
		default: true
		balloonHelp: 'With this focus model, moving the mouse cursor over a window gives the window the input focus.'
		projectLocal: false
		changeInformee: nil
		changeSelector: nil! !

!SloppyFocusInfo methodsFor: 'as yet unclassified' stamp: 'Samir Saidani 1/30/2004 01:42'!
readmeText
^ 'BUG : weird behavior for double-click on inspector'! !

!SubWindow methodsFor: '*sloppy focus-top window' stamp: 'Samir Saidani 1/31/2004 02:43'!
activate
Preferences sloppyFocus ifFalse: [
	super activate. 
	owner activate]! !
